import unittest
from pyppo.actor import PipelineActor
from unittest.mock import Mock


class ActorPipelineTestCase(unittest.TestCase):

    def test_pipeline_actor_calls_subsquent(self):
        first_function = Mock()
        first_function.return_value = {'a': 1}
        second_function = Mock()
        first_function.return_value = {'a': 1}

        class TestPipelineActor(PipelineActor):
            pipeline_steps = [
                first_function,
                second_function
            ]

        pipeline_actor = TestPipelineActor()
        pipeline_actor._execute({'a': 1})

        self.assertTrue(first_function.called)
        self.assertEqual(first_function.call_args[0][0], {'a': 1})
        self.assertTrue(second_function.called)
        self.assertEqual(second_function.call_args[0][0], {'a': 1})


unittest.main()
